package cn.feewee.amap3d

import com.facebook.react.ReactPackage
import com.facebook.react.bridge.NativeModule
import com.facebook.react.bridge.ReactApplicationContext
import com.facebook.react.uimanager.ViewManager
import cn.feewee.amap3d.map_view.*
import cn.feewee.amap3d.modules.SdkModule
import cn.feewee.amap3d.modules.AMapGeolocationModule

class AMap3DPackage : ReactPackage {
  override fun createNativeModules(reactContext: ReactApplicationContext): List<NativeModule> {
    return listOf(
      SdkModule(reactContext),
      new AMapGeolocationModule(reactContext)
    )
  }

  override fun createViewManagers(reactContext: ReactApplicationContext): List<ViewManager<*, *>> {
    return listOf(
      MapViewManager(),
      MarkerManager(),
      PolylineManager(),
      PolygonManager(),
      CircleManager(),
      HeatMapManager(),
      MultiPointManager()
    )
  }
}
